'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _require = require('oauth'),
    OAuth = _require.OAuth;

var qs = require('querystring');

_extends(OAuth.prototype, {
  getXAuthAccessToken: function getXAuthAccessToken(username, password, callback) {
    var xauthParams = {
      'x_auth_mode': 'client_auth',
      'x_auth_password': password,
      'x_auth_username': username
    };

    this._performSecureRequest(null, null, this._clientOptions.accessTokenHttpMethod, this._accessUrl, xauthParams, null, null, function (error, data, response) {
      if (error) callback(error);else {
        var results = qs.parse(data);
        var oauthAccessToken = results['oauth_token'];
        delete results['oauth_token'];
        var oauthAccessTokenSecret = results['oauth_token_secret'];
        delete results['oauth_token_secret'];
        callback(null, oauthAccessToken, oauthAccessTokenSecret, results);
      }
    });
  }
});

module.exports = OAuth;